#include <dlfcn.h>
#include <iostream>

typedef void (* func_ptr)();

int main(int argc, char *argv[]) {
  void *handle = dlopen("./library.so", RTLD_LAZY);
  if(!handle) {
    std::cout << "Can’t load shared object" << std::endl;
    return 1;
  }
  func_ptr hello = (func_ptr)dlsym(handle, "print_message");	
  if(hello != NULL)
    hello();
  
  dlclose(handle);	
 
  return 0;
}
